// Display statistics of your lucky numbers from 0 to 99

PFont label;
int max = 99;

void setup() {
  size(800, 800);
  background(0);
  smooth();

  //Create the font to make text with
  label = createFont("Helvetica", 24);

  // Load and convert string of numbers
  int[] numbers = int(split(join(loadStrings("numbers.txt"), " "), ' '));

  // Draw dot graph
  dotGraph(numbers);

  // Draw bar graph
  //barGraph(numbers, height/2);

  // Draw tile grid
  //int margin = width/20;
  //int s = int((width - 2 * margin) / 10);
  //colorGridTile(numbers, margin, margin, s);

  // Draw number grid
  //int margin = width/20;
  //int s = int((width - 2 * margin) / 10);
  //colorGridNumber(numbers, margin, margin, s);
};

void draw() {
};


void dotGraph(int[] numbers) {
  fill(255, 60); // lighter points are more frequent
  noStroke();
  for (int i = 0; i < numbers.length; i++) {
    ellipse(numbers[i] * 8, width/2, 8, 8);
  }
}

void barGraph(int[] nums, float y) {
  // make a list of number counts
  int[] counts = new int[max+1];
  // fill it with zeros
  for (int i = 0; i < counts.length; i++) {
    counts[i] = 0;
  };
  // tally the counts
  for (int i = 0; i < nums.length; i++) {
    counts[nums[i]]++;
  };

  // draw the bar graph
  for (int i = 0; i < counts.length; i++) {
    colorMode(HSB);
    fill(counts[i] * 30, 255, 255); // same frequency same color
    rect(i * 8, y, 8, counts[i] * 10); // height of bar proportional to frequency
    //rect(i * 8, y, 8, -counts[i] * 10); // bottom-up
  };
};

void colorGridTile(int[] nums, float x, float y, float s) {
  // make a list of number counts
  int[] counts = new int[max+1];

  // fill it with zeros
  for (int i = 0; i < counts.length; i++) {
    counts[i] = 0;
  };

  // tally the counts
  for (int i = 0; i < nums.length; i++) {
    counts[nums[i]] ++;
  };

  //Move the drawing coordinates to the x,y position specified in the parameters
  pushMatrix();
  translate(x, y);
  //Draw the grid
  int maxCounts = max(counts);
  for (int i = 0; i < counts.length; i++) {
    float mapCounts = map(counts[i], 0, maxCounts, 0, 255);
    fill(mapCounts, 0, 0);
    rect((i % 10) * s, floor(i/10) * s, s, s);
  };
  popMatrix();
};

void colorGridNumber(int[] nums, float x, float y, float s) {
  //Make a list of number counts
  int[] counts = new int[max+1];
  //Fill it with zeros
  for (int i = 0; i < counts.length; i++) {
    counts[i] = 0;
  };
  //Tally the counts
  for (int i = 0; i < nums.length; i++) {
    counts[nums[i]] ++;
  };

  pushMatrix();
  translate(x, y);
  int maxCounts = max(counts);
  for (int i = 0; i < counts.length; i++) {
    colorMode(HSB);
    float mapCounts = map(counts[i], 0, maxCounts, 0, 255);
    fill(128, 255, 255, mapCounts); // brighter numbers are more frequent
    textAlign(CENTER);
    textFont(label);
    textSize(s/2);
    text(i, (i % 10) * s + s/2, floor(i/10) * s + s/2);
  };
  popMatrix();
};
